// LERA: Wave View
//       
unit lrwvvw;

interface
uses Inferno, Mikky, lrwvfm, Alf, Ini, X, X11, XUtil, XLib, VGAColors;

//      
procedure wvvwNewFile(const NewName: String);

//     
procedure wvvwNewPos(const NewPos: Cardinal);

//        
function  wvvwSec2Str(const v: Single): String;

const
  ColT1		= 10;				//  
  ColT2		= 12;
  ColM1		= 11;
  ColM2		= 14;

  ColLeft	= 14;				//    
  ColRight	= 11;

  wvvwNewUserPosFlag	: Boolean = False;	//    
  wvvwNewUserPos	: Cardinal = 0;

var
  wvvwPos		: Cardinal;		//   ()
  wvvwT1, wvvwT2	: Cardinal;		//     ()
  wvvwM1, wvvwM2	: Cardinal;
  wvvwWaveWasReBuild	: Boolean;		// True,     (  wvvwNewPos)
  wvvwWndMain,
  wvvwWndStat		: TWindow;


implementation

const
  TimeFmt	: (tfSec, tfMinSec) = tfMinSec;	//   
  CurBlock	: Cardinal = 1;			//  Map/UnMap 

  flSwLf	: Boolean = True;		//   
  flSwRt	: Boolean = True;		//   

  Sec2Win	= 1;				//     
  FileName	: String = '';			//  

  FontStat	: String = '-*-courier-medium-r-*-*-*-*-*-*-*-*-koi8-*'; //   

  Border 	= 8;				//   

  WndMainX	: LongInt = 405;		//     
  WndMainY	: LongInt = 148;
  WndMainW	: LongInt = 575;
  WndMainH	: LongInt = 292;

  WndStatX	: LongInt = 405;		//     
  WndStatY	: LongInt = 010;
  WndStatW	: LongInt = 338;
  WndStatH	: LongInt = 210;
  
  WndScrollW	: LongInt = 565;		// 
  WndScrollH	= 20;
  ScrollW	= 2;				//   

  ButtonH	= 20;				//  

  ToCenter	: Boolean = False;		//        
  ReBuildMode	: Boolean = False;		//     
						// (       OX    )
  ExposeMode	: Boolean = True;		//   

  MinScrollScale: Single = 0.005;		//   ,      

var
  OldFullingTime	: TFullingTime;
  OldExitProc		: pointer;

  Pix2Sample		: Single;		//   X (pix/sample)
  ScaleY		: Longint;		//  Y
  CursorX		: LongInt;		//    

  WndWaveW, WndWaveH	: LongInt;		//   , pixel

  msSwLf, msSwRt, msScroll, msWave,		//  / , ,  
  msMvSl, msMvFs, msSclX, msSclY, msStat,	// , , 
  msT1, msT2, msM1, msM2: RngMouseArea;		//  
  msF		: Array[1..2] of RngMouseArea;	//  
  FmtSX		: Array[1..2] of Single;	//  Pix2Sample
  FmtSY		: Array[1..2] of LongInt;	//  ScalyY

  PixMap		: TPixMap;


//      TimeFmt
function  wvvwSec2Str(const v: Single): String;
var vr: LongInt;
begin
  case TimeFmt of
  tfSec		: wvvwSec2Str := ValToStrGExt(v, 10, 3) + ' ';
  tfMinSec	: begin
    vr := Round(v);
    wvvwSec2Str := ValToStrG(vr div 60, 5) + ':' + ValToStrG(vr mod 60, 2) + ' :';
  end;
  end;
end;


//  
procedure intDrawScrool(const Wnd: TWindow; var GC: TGC; const Colors: TColors; var dt);
var x: LongInt;

  procedure CalcX(const Pos: Cardinal);
  begin x := ScrollW + Round( (Pos / wvRlen) * (WndScrollW - ScrollW*2) ) end;

  procedure BuildMark(const c: Byte; const Pos: Cardinal);
  begin XSetForeGround(prDisplay, GC, Colors[c]); CalcX(Pos); XDrawLine(prDisplay, Wnd, GC, x, 0, x, WndScrollH) end;

begin
  XClearWindow(prDisplay, Wnd);
  if wvRlen <> 0 then begin
    CalcX(wvvwPos);
    XFillRectangle(prDisplay, Wnd, GC, x - ScrollW, 0, ScrollW * 2, WndScrollH);
    XSetForeGround(prDisplay, GC, Colors[7]);
    XDrawLine(prDisplay, Wnd, GC, 0, WndScrollH div 2, WndScrollW, WndScrollH div 2);
    BuildMark(ColT1, wvvwT1); BuildMark(ColT2, wvvwT2);
    BuildMark(ColM1, wvvwM1); BuildMark(ColM2, wvvwM2);
  end;
end;


//   
procedure intDrawWave(const Wnd: TWindow; var GC: TGC; const Colors: TColors; var dt);
const
  CursorH		= 10;			//  
  CursorW		= 10;			//  
  CentralSample		: Cardinal = 0;		//  ,     
  PrevCentralSample	: Cardinal = 0;
  PrevWaveW		: LongInt = 0;		//   
  PrevWaveH		: LongInt = 0;		//  ,   ConfigureNotify,
						// ..         

var
  NoScrollArea		: Cardinal;		// 85 %   ,  
  WndWaveHcr,					//       =      
  WndWaveCenterX,
  WndWaveCenterY	: Longint;		//  
  //     PixMap
  procedure BuildGraph;
  var
    XReal, ScaleYinternal	: Single;	//    (pixel),  Y
    SampleL, SampleR		: Integer;	//     
    XInteger, PrevXInteger,			//      (pixel)
    PrevSampleLY,PrevSampleRY	: LongInt;	//   
    flRealyShowLine		: Boolean;	//     
    MarkColor			: Byte;		//    0,      
    NoScrollAreaPix,				// 85 %  ,  
    ScrollAreaPix		: Cardinal;	//    ,  

    procedure DrawChanel(const Enable: Boolean; const Sample: Integer; var PrevSampleY: LongInt; const Col: Byte);
    var SampleY: LongInt;
    begin if Enable then begin
      SampleY := WndWaveCenterY - Round(Sample / ScaleYinternal);
      if flRealyShowLine then begin
	XSetForeGround(prDisplay, GC, Colors[8]);
	XDrawLine(prDisplay, PixMap, GC, PrevXInteger, PrevSampleY, XInteger, SampleY);
      end;
      XSetForeGround(prDisplay, GC, Colors[Col]);
      XDrawPoint(prDisplay, PixMap, GC, PrevXInteger, PrevSampleY);
      PrevSampleY := SampleY;
    end end;

  begin
    flRealyShowLine := 0.5 < Pix2Sample;
    
//    XClearWindow(prDisplay, PixMap);
    NoScrollAreaPix := Round(WndWaveW * 0.85); ScrollAreaPix := (WndWaveW - NoScrollAreaPix) div 2 + 1;
    XSetForeGround(prDisplay, GC, Colors[0]);
    XFillRectangle(prDisplay, PixMap, GC, ScrollAreaPix, 0, NoScrollAreaPix, WndWaveH);
    XSetForeGround(prDisplay, GC, Colors[8]);
    XFillRectangle(prDisplay, PixMap, GC,			 0, 0, ScrollAreaPix, WndWaveH);
    XFillRectangle(prDisplay, PixMap, GC, WndWaveW - ScrollAreaPix, 0, ScrollAreaPix, WndWaveH);

    XSetForeGround(prDisplay, GC, Colors[15]); XDrawLine(prDisplay, PixMap, GC, 0, WndWaveCenterY, WndWaveW, WndWaveCenterY);

    if CentralSample < Round(WndWaveCenterX / Pix2Sample) then begin
      XReal := WndWaveCenterX - CentralSample * Pix2Sample;
      wvRposS := 0;
    end else begin
      XReal := WndWaveCenterX - Round(WndWaveCenterX / Pix2Sample) * Pix2Sample;
      wvRposS := CentralSample - Round(WndWaveCenterX / Pix2Sample);
    end;
    PrevXInteger := Round(XReal) - 1;
    ScaleYinternal := (wvMaxVal-wvMinVal) / WndWaveHcr / ScaleY;
    PrevSampleLY := WndWaveCenterY; PrevSampleRY := WndWaveCenterY;

    while (XReal < WndWaveW) and (wvRposS < wvRlen) do begin
//    repeat
      XInteger := Round(XReal);

      MarkColor := 0;
      if wvRposS = wvvwT1 then MarkColor := ColT1;
      if wvRposS = wvvwT2 then MarkColor := ColT2;
      if wvRposS = wvvwM1 then MarkColor := ColM1;
      if wvRposS = wvvwM2 then MarkColor := ColM2;
      if MarkColor <> 0 then begin
        XSetForeGround(prDisplay, GC, Colors[MarkColor]);
        XDrawLine(prDisplay, PixMap, GC, XInteger, 0, XInteger, WndWaveHcr);
      end;

      getSample(SampleL, SampleR);

      DrawChanel(flSwLf,			SampleL, PrevSampleLY, ColLeft);
      DrawChanel(flSwRt and (wvRchanels=2),	SampleR, PrevSampleRY, ColRight);
      
      PrevXInteger := XInteger; 
      XReal := XReal + Pix2Sample;
//    until (XReal >= WndWaveW) or (wvRposS >{=} wvRlen);
    end;
  end;


  //  PixMap  
  procedure ExposeGraph;
  begin
    XSetGraphicsExposures(prDisplay, GC, False);
    XCopyArea(prDisplay, PixMap, Wnd, GC, 0, 0, GetMaxX, GetMaxY, 0, 0);
  end;


  //    
  procedure BuildCursor(const c: Byte);
  var k: array[0..2] of TXPoint;
  begin
    XSetForeGround(prDisplay, GC, Colors[c]);
    k[0].x := CursorX - CursorW; k[0].y := WndWaveHcr + CursorH;
    k[1].x := CursorX;		 k[1].y := WndWaveHcr;
    k[2].x := CursorX + CursorW; k[2].y := WndWaveHcr + CursorH;
    XFillPolygon(prDisplay, Wnd, GC, @k, 3, Convex, CoordModeOrigin);
  end;

begin
  if WndWaveH > 15 then begin
    WndWaveHcr := WndWaveH - CursorH;
    WndWaveCenterX := WndWaveW div 2; WndWaveCenterY := WndWaveHcr div 2;
    NoScrollArea := Round(WndWaveW / 2 * 0.85 / Pix2Sample);

    if ToCenter then CentralSample := wvvwPos else
      if CentralSample + NoScrollArea < wvvwPos then CentralSample := wvvwPos + NoScrollArea else
        if wvvwPos + NoScrollArea < CentralSample then
	  if wvvwPos < NoScrollArea then CentralSample := 0 else CentralSample := wvvwPos - NoScrollArea;

    if (CentralSample <> PrevCentralSample) or ReBuildMode or (PrevWaveW <> WndWaveW) or (PrevWaveH <> WndWaveH) then begin
      //      
      wvvwWaveWasReBuild := True;
      BuildGraph;
      ExposeGraph;
      PrevWaveW := WndWaveW; PrevWaveH := WndWaveH;
    end else
      if ExposeMode then
        //     
        ExposeGraph
      else
        //   
        BuildCursor(0);    

    CursorX := Round((LongInt(wvvwPos)-LongInt(CentralSample)) * Pix2Sample) + WndWaveCenterX;
    BuildCursor(11);
    ToCenter := False;
    ReBuildMode := False;
    ExposeMode := True;
    PrevCentralSample := CentralSample;
  end;
end;


//   
procedure intDrawStat(const Wnd: TWindow; var GC: TGC; const Colors: TColors; var dt);

  procedure sm(const c: Byte; const s: String; const v: Cardinal);
  begin
    XSetForeGround(prDisplay, GC, Colors[c]);
    jkl(Wnd, GC, s + ValToStrG(v, 8) + '  / ' + wvvwSec2Str(v / wvRfreq));
  end;

  procedure bt(const c: Byte; const s: String; const v: Cardinal; const s1: String);
  begin
    XSetForeGround(prDisplay, GC, Colors[c]);
    jkl(Wnd, GC, s + ValToStrG(v, 8) + s1);
  end;

  procedure kb(const c: Byte; const s: String; const v: Cardinal);
  begin
    XSetForeGround(prDisplay, GC, Colors[c]);
    jkl(Wnd, GC, s + ValToStrGExt(v * wvRrate * wvRchanels / 1024, 8, 0) + '  / ' + wvvwSec2Str(v / wvRfreq));
  end;

begin
  AlfSetFont(GC, FontStat);
//  XClearWindow(prDisplay, Wnd);
  AlfOutTextXY(Wnd, GC, Border, Border, ': "' + FileName + '"');
  if wvRlen <> 0 then begin
    sm(15,	'       :', wvRlen);
    bt(15,	'      :', wvRfreq, ' /');
    bt(15,	'      :', wvRchanels, '');
    bt(15,	' /   :', wvRrate*8, '');
    sm(15,	'  X :', Round(WndWaveW / Pix2Sample));
    bt(15,	' Y :', ScaleY, '');
    sm(15,	'  :', wvvwPos);
    sm(ColT1,	' 1     :', wvvwT1);
    sm(ColT2,	' 2     :', wvvwT2);
    sm(ColM1,	' A     :', wvvwM1);
    sm(ColM2,	' B     :', wvvwM2);
    kb(15,	' 1-2 :', wvvwT2-wvvwT1);
    kb(15,	' A-B :', wvvwM2-wvvwM1);
    kb(15,	' 1-B :', wvvwM2-wvvwT1);
  end else begin
    jkl(Wnd, GC, '       !');
  end;
end;


//         
procedure intSetButtonSize;
const nb = 6;
var xbs: LongInt;
begin
  xbs := (WndMainW - Border) div nb;
  SetMouseArea(msMvSl,	msActive, Border + xbs*0, WndMainH - (Border+ButtonH)*2, xbs - Border, ButtonH, 15,	 8, '< >',	XC_sb_h_double_arrow);
  SetMouseArea(msMvFs,	msActive, Border + xbs*1, WndMainH - (Border+ButtonH)*2, xbs - Border, ButtonH, 15,	 8, '<< >>',	XC_sb_h_double_arrow);
  SetMouseArea(msSclX,	msActive, Border + xbs*2, WndMainH - (Border+ButtonH)*2, xbs - Border, ButtonH, 15,	 8, 'Zoom',	XC_sb_h_double_arrow);
  SetMouseArea(msSclY,	msActive, Border + xbs*3, WndMainH - (Border+ButtonH)*2, xbs - Border, ButtonH, 15,	 8, 'Zoom',	XC_sb_v_double_arrow);
  SetMouseArea(msT1,	msActive, Border + xbs*4, WndMainH - (Border+ButtonH)*2, xbs - Border, ButtonH, ColT1,	 8, 'M 1',	XC_left_side);
  SetMouseArea(msM1,	msActive, Border + xbs*5, WndMainH - (Border+ButtonH)*2, xbs - Border, ButtonH, ColM1,	 8, 'M A',	XC_left_tee);

  SetMouseArea(msF[1],	msActive, Border + xbs*0, WndMainH - (Border+ButtonH)*1, xbs - Border, ButtonH, 15,	 8, 'F 1',	XC_umbrella);
  SetMouseArea(msF[2],	msActive, Border + xbs*1, WndMainH - (Border+ButtonH)*1, xbs - Border, ButtonH, 15,	 8, 'F 2',	XC_umbrella);
  SetMouseArea(msSwLf,	msActive, Border + xbs*2, WndMainH - (Border+ButtonH)*1, xbs - Border, ButtonH, ColLeft, 8, 'Left',	XC_top_left_corner);
  SetMouseArea(msSwRt,	msActive, Border + xbs*3, WndMainH - (Border+ButtonH)*1, xbs - Border, ButtonH, ColRight,8, 'Right',	XC_top_right_corner);
  SetMouseArea(msT2,	msActive, Border + xbs*4, WndMainH - (Border+ButtonH)*1, xbs - Border, ButtonH, ColT2,	 8, 'M 2',	XC_right_tee);
  SetMouseArea(msM2,	msActive, Border + xbs*5, WndMainH - (Border+ButtonH)*1, xbs - Border, ButtonH, ColM2,	 8, 'M B',	XC_right_side);

  WndWaveW := WndMainW - Border*2; WndWaveH := WndMainH - (Border+ButtonH)*2 - Border*3 - WndScrollH;
  SetMouseArea(msScroll,msActive, Border, WndMainH - (Border+ButtonH)*2 - Border - WndScrollH, WndMainW - Border*2, WndScrollH, 15, 0, '', XC_sb_h_double_arrow);
  SetMouseArea(msWave,	msActive, Border, Border, WndWaveW, WndWaveH, 15, 0, '', XC_center_ptr);
  SetMouseArea(msStat,	msActive, 0, 0, WndStatW, WndStatH, 15, 0, '', XC_X_cursor);
end;


//       
procedure intCreateWindows;
begin
  IniOpen('Wave Viewer Geometry');
  IniGet('Main X', WndMainX); IniGet('Main Width',  WndMainW);
  IniGet('Main Y', WndMainY); IniGet('Main Heigth', WndMainH);
  IniGet('Stat X', WndStatX); IniGet('Stat Width',  WndStatW);
  IniGet('Stat Y', WndStatY); IniGet('Stat Heigth', WndStatH);
  IniClose;
  
  NewRootWindow(WndMainX, WndMainY, WndMainW, WndMainH, 20, 20, ' ', ' ', wvvwWndMain);
  NewRootWindow(WndStatX, WndStatY, WndStatW, WndStatH, 20, 20, '  ', '  ', wvvwWndStat);

  NewMouseArea(wvvwWndMain, msMvSl);
  NewMouseArea(wvvwWndMain, msMvFs);
  NewMouseArea(wvvwWndMain, msSclX);
  NewMouseArea(wvvwWndMain, msSclY);
  NewMouseArea(wvvwWndMain, msT1);
  NewMouseArea(wvvwWndMain, msM1);

  NewMouseArea(wvvwWndMain, msF[1]);
  NewMouseArea(wvvwWndMain, msF[2]);
  NewMouseArea(wvvwWndMain, msSwLf);
  NewMouseArea(wvvwWndMain, msSwRt);
  NewMouseArea(wvvwWndMain, msT2);
  NewMouseArea(wvvwWndMain, msM2);

  NewMouseArea(wvvwWndMain, msScroll); SetMouseRoutines(msScroll, @intDrawScrool, msScroll, Nil, Nil, Nil);
  NewMouseArea(wvvwWndMain, msWave);   SetMouseRoutines(msWave,   @intDrawWave,   msWave,   Nil, Nil, Nil);
  NewMouseArea(wvvwWndStat, msStat);   SetMouseRoutines(msStat,   @intDrawStat,   msStat,   Nil, Nil, Nil);

  intSetButtonSize;
  
  PixMap := XCreatePixMap(prDisplay, wvvwWndMain, GetMaxX, GetMaxY, ColorDepth);
end;


// / -
procedure ParamLoad;
begin
  Pix2Sample := WndWaveW/(wvRfreq*Sec2Win);
  FmtSX[1] := WndWaveW/(wvRfreq*Sec2Win)*2;
  FmtSX[2] := WndWaveW/(wvRfreq*Sec2Win)/2;
  ScaleY := 1;
  FmtSY[1] := 1;
  FmtSY[2] := 4;
  wvvwT1 := 0;
  wvvwT2 := $7fffffff;
  wvvwM1 := 0;
  wvvwM2 := $7fffffff;
  wvvwT1 := 0;
  wvvwT2 := $7fffffff;
  wvvwM1 := 0;
  wvvwM2 := $7fffffff;

  IniOpen(FileName);
  IniGet('Scale X',		Pix2Sample);
  IniGet('F 1 X',		FmtSX[1]);
  IniGet('F 2 X',		FmtSX[2]);
  IniGet('Scale Y',		ScaleY);
  IniGet('F 1 Y',		FmtSY[1]);
  IniGet('F 2 Y',		FmtSY[2]);
  IniGet('Pos 1',		wvvwT1);
  IniGet('Pos 2',		wvvwT2);
  IniGet('Pos A',		wvvwM1);
  IniGet('Pos B',		wvvwM2);
  IniGet('Marker pos',		wvvwPos);
  IniGet('Show left samples',	flSwLf);
  IniGet('Show right samples',	flSwRt);
  IniClose;
end;

procedure ParamSave;
begin
  if FileName<>'' then begin
    IniOpen(FileName);
    IniPut('Scale X',		Pix2Sample);
    IniPut('F 1 X',		FmtSX[1]);
    IniPut('F 2 X',		FmtSX[2]);
    IniPut('Scale Y',		ScaleY);
    IniPut('F 1 Y',		FmtSY[1]);
    IniPut('F 2 Y',		FmtSY[2]);
    IniPut('Pos 1',		wvvwT1);
    IniPut('Pos 2',		wvvwT2);
    IniPut('Pos A',		wvvwM1);
    IniPut('Pos B',		wvvwM2);
    IniPut('Marker pos',	wvvwPos);
    IniPut('Show left samples',	flSwLf);
    IniPut('Show right samples',flSwRt);
    IniClose;
  end;
end;


//    
procedure wvvwNewFile(const NewName: String);
  procedure RangeCheck(var pos: Cardinal);
  begin if pos > wvRlen then pos := wvRlen end;
begin
  XClearWindow(prDisplay, GetMouseWnd(msStat)); //      "  "
  ParamSave;
  FileName := NewName;
  ParamLoad;
  RangeCheck(wvvwT1);
  RangeCheck(wvvwT2);
  RangeCheck(wvvwM1);
  RangeCheck(wvvwM2);
  RangeCheck(wvvwPos);
  ToCenter := True;
  DrawButton(msStat);
  DrawButton(msWave);
  DrawButton(msScroll);
end;


//      
procedure wvvwNewPos(const NewPos: Cardinal);
begin
  wvvwPos := NewPos;
  DrawButton(msStat);
  DrawButton(msWave);
  DrawButton(msScroll);
end;


//      (  )
procedure intEnterNewPos(var v: Cardinal);
var
  s		: AlfTStr;
  i, p		: LongInt;
  v2, vOrg	: Cardinal;
  Sign		: (snNo, snPl, snMn);

begin
  vOrg := v; s := wvvwSec2Str(v / wvRfreq);
  p := pos('.', s); if p <> 0 then SetLength(s, p-1);
  if AlfEnterString(s, '[+|-]   : - ', MouseXroot, MouseYroot) then else begin
    case s[1] of
      '+': Sign := snPl;
      '-': Sign := snMn;
      else Sign := snNo;
    end;
    if Sign <> snNo then delete(s, 1, 1);
    p := 1;
    while p <= length(s) do if s[p] in ['0'..'9', ':'] then inc(p) else delete(s, p, 1);
    p := pos(':', s);
    if p <> 0 then begin
      v2 := 0;
      val(copy(s, 1, p-1), v2, i);
      delete(s, 1, p);
      p := pos(':', s);
      if p = 0 then val(s, v, i) else val(copy(s, 1, p-1), v, i);
      v := v2 * 60 + v;
    end else begin
      val(s, v, i);
    end;
    v := v * wvRfreq;
    case Sign of
      snPl: v := vOrg + v;
      snMn: v := vOrg - v;
    end;
    if wvvwPos > wvRlen then wvvwPos := wvRlen;
    ToCenter := True;
    DrawButton(msStat);
    DrawButton(msWave);
    DrawButton(msScroll);
  end;
end;


//    
procedure intCorrectMarkers;
var tmp: Cardinal;
begin
  if wvvwT1 > wvvwM2 then begin
    tmp := wvvwT1; wvvwT1 := wvvwM1; wvvwM1 := tmp;
    tmp := wvvwT2; wvvwT2 := wvvwM2; wvvwM2 := tmp;
  end;
//  wvvwNewPos(wvvwPos);
end;


//  
procedure wvvwFullingTime(var Event: TXEvent; const BlockEn: Boolean);

  procedure decchk(var v: Cardinal; const d: Cardinal);
  begin if v < d then v := 0 else dec(v, d) end;

begin
  OldFullingTime(Event, BlockEn);
  case Event.EventType of

    MotionNotify: if TestButton(MouseLmsk) then begin
      if MouseInArea(msScroll) and (wvRlen <> 0) and (MouseX >= 0) and (MouseX <= WndScrollW) then begin
        wvvwPos := Round( MouseX / WndScrollW * wvRlen );
	ExposeMode := False;
	if Pix2Sample > MinScrollScale then DrawButton(msWave);
        DrawButton(msStat);
        DrawButton(msScroll);
      end;
      if MouseInArea(msWave) then begin
         if wvvwPos >= (CursorX - MouseX) / Pix2Sample then wvvwPos := Round( wvvwPos - (CursorX - MouseX) / Pix2Sample ) else wvvwPos := 0;
         if wvvwPos > wvRlen then wvvwPos := wvRlen;
	 ExposeMode := False;
         DrawButton(msStat);
         DrawButton(msWave);
         DrawButton(msScroll);
      end;
      wvvwNewUserPos := wvvwPos;
    end;

    ButtonRelease: if CurrentWindow = wvvwWndMain then begin
      ReBuildMode := True;
      ToCenter := not MouseInArea(msWave);
      DrawButton(msStat);
      DrawButton(msWave);
      DrawButton(msScroll);
      if MouseInArea(msWave) or MouseInArea(msScroll) then wvvwNewUserPosFlag := True;
    end;

    ButtonPress: With Event.XButton do begin
      if CurrentWindow = wvvwWndMain then begin
        if MouseInArea(msSwLf) then flSwLf := not flSwLf;
        if MouseInArea(msSwRt) then flSwRt := not flSwRt;
        if MouseInArea(msWave) then if wvvwPos >= (CursorX - MouseX) / Pix2Sample then wvvwPos := Round( wvvwPos - (CursorX - MouseX) / Pix2Sample ) else wvvwPos := 0;

        if TestButton(MouseLmsk) then begin
          if MouseInArea(msMvSl) then decchk(wvvwPos, 1);
          if MouseInArea(msMvFs) then if TestMKey(skLShift) then decchk(wvvwPos, 10000) else decchk(wvvwPos, 100);
          if MouseInArea(msSclX) then Pix2Sample := Pix2Sample * 2;
          if MouseInArea(msT1) then if wvvwPos>wvvwT2 then begin wvvwT1 := wvvwT2; wvvwT2 := wvvwPos end else wvvwT1 := wvvwPos;
          if MouseInArea(msT2) then if wvvwT1>wvvwPos then begin wvvwT2 := wvvwT1; wvvwT1 := wvvwPos end else wvvwT2 := wvvwPos;
          if MouseInArea(msM1) then if wvvwPos>wvvwM2 then begin wvvwM1 := wvvwM2; wvvwM2 := wvvwPos end else wvvwM1 := wvvwPos;
          if MouseInArea(msM2) then if wvvwM1>wvvwPos then begin wvvwM2 := wvvwM1; wvvwM1 := wvvwPos end else wvvwM2 := wvvwPos;
          if MouseInArea(msSclY) then ScaleY := ScaleY * 2;
          if MouseInArea(msF[1]) then begin Pix2Sample := FmtSX[1]; ScaleY := FmtSY[1] end;
          if MouseInArea(msF[2]) then begin Pix2Sample := FmtSX[2]; ScaleY := FmtSY[2] end;
          if MouseInArea(msScroll) and (wvRlen <> 0) and (MouseX >= 0) and (MouseX <= WndScrollW) then wvvwPos := Round( MouseX / WndScrollW * wvRlen );
        end;
        if TestButton(MouseRmsk) then begin
          if MouseInArea(msMvSl) then inc(wvvwPos);
          if MouseInArea(msMvFs) then if TestMKey(skLShift) then inc(wvvwPos,10000) else inc(wvvwPos,100);
          if MouseInArea(msSclX) then Pix2Sample := Pix2Sample / 2;
          if MouseInArea(msT1) then wvvwPos := wvvwT1;
          if MouseInArea(msT2) then wvvwPos := wvvwT2;
          if MouseInArea(msM1) then wvvwPos := wvvwM1;
          if MouseInArea(msM2) then wvvwPos := wvvwM2;
          if MouseInArea(msSclY) then ScaleY := ScaleY div 2;
          if MouseInArea(msScroll) then intEnterNewPos(wvvwPos);
          if MouseInArea(msF[1]) then begin FmtSX[1] := Pix2Sample; FmtSY[1] := ScaleY end;
          if MouseInArea(msF[2]) then begin FmtSX[2] := Pix2Sample; FmtSY[2] := ScaleY end;
        end;
        if wvvwPos > wvRlen then wvvwPos := wvRlen;
        if Pix2Sample < 0.001 then Pix2Sample := 0.001;
        if Pix2Sample > WndWaveW then Pix2Sample := WndWaveW;
        if ScaleY < 1 then ScaleY := 1;
        if ScaleY > wvMaxVal - wvMinVal then ScaleY := wvMaxVal - wvMinVal;
	intCorrectMarkers;
	DrawButton(msWave);
        DrawButton(msStat);
        DrawButton(msScroll);
	wvvwNewUserPos := wvvwPos;
      end;
      if MouseInArea(msStat) then begin
        if TimeFmt = tfSec then TimeFmt := tfMinSec else TimeFmt := tfSec;
        DrawButton(msStat);
      end;
    end;

    ConfigureNotify: with Event.XConfigure do begin
      if Window = wvvwWndMain then begin
        WndMainW := Width; WndMainH := Height;
	WndScrollW := Width - Border * 2;
        intSetButtonSize;
      end;
      if Window = wvvwWndStat then begin
        WndStatW := Width - WndBorder * 2; WndStatH := Height - WndBorder * 2;
        intSetButtonSize;
      end;
    end;

  end;
end;


procedure intExitProc; begin ExitProc := OldExitProc; ParamSave end;

begin
  IniOpen('Wave Viewer'); IniGet('FontStat', FontStat); IniGet('Minimal Scroll Scale', MinScrollScale); IniClose;

  OldFullingTime := FullingTime;	FullingTime := @wvvwFullingTime;
  OldExitProc := ExitProc;		ExitProc := @intExitProc;
  intCreateWindows;
end.
